VERSION 5.00
Begin VB.Form Form1 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "VEval/VFormat demo"
   ClientHeight    =   2970
   ClientLeft      =   45
   ClientTop       =   390
   ClientWidth     =   7410
   BeginProperty Font 
      Name            =   "Segoe UI"
      Size            =   9
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   MaxButton       =   0   'False
   ScaleHeight     =   2970
   ScaleWidth      =   7410
   StartUpPosition =   2  'CenterScreen
   Begin VB.CheckBox chkHexOctalAllowed 
      Caption         =   "HexOctalAllowed"
      Height          =   315
      Left            =   4500
      TabIndex        =   4
      Top             =   120
      Width           =   1875
   End
   Begin VB.CheckBox chk10K 
      Caption         =   "Test ten thousand iterations"
      Height          =   315
      Left            =   1380
      TabIndex        =   7
      Top             =   960
      Width           =   2715
   End
   Begin VB.ComboBox cboLCID 
      Height          =   345
      Left            =   3120
      Style           =   2  'Dropdown List
      TabIndex        =   3
      Top             =   120
      Width           =   1215
   End
   Begin VB.ComboBox cboParsedTypes 
      Height          =   345
      Left            =   1380
      Style           =   2  'Dropdown List
      TabIndex        =   1
      Top             =   120
      Width           =   1215
   End
   Begin VB.CommandButton cmdEvaluate 
      Caption         =   "Evaluate"
      Default         =   -1  'True
      Height          =   495
      Left            =   1380
      TabIndex        =   8
      Top             =   1380
      Width           =   1215
   End
   Begin VB.TextBox txtExpression 
      Height          =   345
      Left            =   1380
      TabIndex        =   6
      Text            =   "3+5*9+7+2*5"
      Top             =   540
      Width           =   5955
   End
   Begin VB.Label Label6 
      Alignment       =   1  'Right Justify
      Caption         =   "Milliseconds:"
      Height          =   255
      Left            =   60
      TabIndex        =   13
      Top             =   2550
      Width           =   1275
   End
   Begin VB.Label lblMs 
      BorderStyle     =   1  'Fixed Single
      Height          =   315
      Left            =   1380
      TabIndex        =   14
      Top             =   2520
      Width           =   1695
   End
   Begin VB.Label Label2 
      Alignment       =   1  'Right Justify
      Caption         =   "LCID"
      Height          =   255
      Left            =   2700
      TabIndex        =   2
      Top             =   180
      Width           =   375
   End
   Begin VB.Label lblReturnedValue 
      BorderStyle     =   1  'Fixed Single
      Height          =   315
      Left            =   4500
      TabIndex        =   12
      Top             =   2040
      Width           =   2835
   End
   Begin VB.Label Label5 
      Alignment       =   1  'Right Justify
      Caption         =   "Returned value:"
      Height          =   255
      Left            =   3180
      TabIndex        =   11
      Top             =   2070
      Width           =   1275
   End
   Begin VB.Label lblReturnedType 
      BorderStyle     =   1  'Fixed Single
      Height          =   315
      Left            =   1380
      TabIndex        =   10
      Top             =   2040
      Width           =   1695
   End
   Begin VB.Label Label4 
      Alignment       =   1  'Right Justify
      Caption         =   "Returned type:"
      Height          =   255
      Left            =   60
      TabIndex        =   9
      Top             =   2070
      Width           =   1275
   End
   Begin VB.Label Label1 
      Alignment       =   1  'Right Justify
      Caption         =   "ParsedTypes:"
      Height          =   255
      Left            =   60
      TabIndex        =   0
      Top             =   180
      Width           =   1275
   End
   Begin VB.Label Label3 
      Alignment       =   1  'Right Justify
      Caption         =   "Expression:"
      Height          =   255
      Left            =   60
      TabIndex        =   5
      Top             =   600
      Width           =   1215
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Declare Function GetTickCount Lib "kernel32" () As Long

Private Sub cmdEvaluate_Click()
    Dim Iterations As Long
    Dim T0 As Long
    Dim I As Long
    Dim Result As Variant

    With VEval
        .ParsedTypes = cboParsedTypes.ItemData(cboParsedTypes.ListIndex)
        .LCID = cboLCID.ItemData(cboLCID.ListIndex)
        VFormat.LCID = .LCID
        .HexOctalAllowed = chkHexOctalAllowed.Value = vbChecked
    End With
    If chk10K.Value = vbChecked Then
        Iterations = 10000
    Else
        Iterations = 1
    End If
    T0 = GetTickCount()
    On Error Resume Next
    For I = 1 To Iterations
        Result = VEval(txtExpression.Text)
    Next
    If Err Then
        lblReturnedType.Caption = " Error"
        lblReturnedValue.Caption = " " & Err.Description
        lblReturnedValue.ToolTipText = Err.Description
        On Error GoTo 0
    Else
        On Error GoTo 0
        lblReturnedType.Caption = " " & TypeName(Result)
        lblReturnedValue.Caption = " " & VFormat(Result)
        lblReturnedValue.ToolTipText = vbNullString
    End If
    lblMs.Caption = " " & VFormat(GetTickCount() - T0)
    txtExpression.SetFocus
End Sub

Private Sub Form_Load()
    With cboParsedTypes
        .AddItem "default"
        .ItemData(.NewIndex) = [_vtbValid]
        .AddItem "Int"
        .ItemData(.NewIndex) = vtbInt
        .AddItem "Real"
        .ItemData(.NewIndex) = vtbReal
        .AddItem "Integer"
        .ItemData(.NewIndex) = vtbInteger
        .AddItem "Long"
        .ItemData(.NewIndex) = vtbLong
        .AddItem "Single"
        .ItemData(.NewIndex) = vtbSingle
        .AddItem "Double"
        .ItemData(.NewIndex) = vtbDouble
        .AddItem "Currency"
        .ItemData(.NewIndex) = vtbCurrency
        .AddItem "Decimal"
        .ItemData(.NewIndex) = vtbDecimal
        .ListIndex = 0
    End With
    With cboLCID
        .AddItem "default"
        .ItemData(.NewIndex) = 0
        .AddItem "ENUK"
        .ItemData(.NewIndex) = LCID_ENUK
        .AddItem "ENUS"
        .ItemData(.NewIndex) = LCID_ENUS
        .AddItem "DEDE"
        .ItemData(.NewIndex) = LCID_DEDE
        .AddItem "FIFI"
        .ItemData(.NewIndex) = LCID_FIFI
        .AddItem "FRFR"
        .ItemData(.NewIndex) = LCID_FRFR
        .AddItem "invariant"
        .ItemData(.NewIndex) = LCID_INVARIANT
        .ListIndex = 0
    End With
    Show
    txtExpression.SetFocus
End Sub
